package com.diagbot.entity;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 * 首次病程录
 * </p>
 *
 * @author cy
 * @since 2020-10-09
 */
public class MedFirstRecord implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 记录编号
     */
    private String recId;

    /**
     * 医院ID
     */
    private Long hospitalId;

    /**
     * 病历号
     */
    private String behospitalCode;

    /**
     * 姓名
     */
    private String name;

    /**
     * 性别
     */
    private String sex;

    /**
     * 年龄
     */
    private String age;

    /**
     * 床号
     */
    private String bedNo;

    /**
     * 科别
     */
    private String deptName;

    /**
     * 病历日期
     */
    private Date recordDate;

    /**
     * 标题
     */
    private String recTitle;

    /**
     * 主诉
     */
    private String chief;

    /**
     * 现病史
     */
    private String present;

    /**
     * 既往史
     */
    private String pastHistory;

    /**
     * 查体
     */
    private String vital;

    /**
     * 辅检
     */
    private String assistantExam;

    /**
     * 病例特点
     */
    private String caseCharacter;

    /**
     * 初步诊断
     */
    private String tentativeDiagnosis;

    /**
     * 诊断依据
     */
    private String supplyDiagnosis;

    /**
     * 鉴别诊断
     */
    private String revisedDiagnosis;

    /**
     * 诊疗计划(方案)
     */
    private String treatPlan;

    /**
     * 记录医生
     */
    private String recDoctor;

    /**
     * 记录时间
     */
    private Date recDate;

    /**
     * 审核医生
     */
    private String auditDoctor;

    /**
     * 审核时间
     */
    private Date auditDate;

    /**
     * 结构化数据
     */
    private String wholeData;

    /**
     * 备注
     */
    private String remark;

    /**
     * 是否删除
     */
    private String isDeleted;

    /**
     * 记录创建时间
     */
    private Date gmtCreate;

    /**
     * 记录修改时间
     */
    private Date gmtModified;

    /**
     * 创建人
     */
    private String creator;

    /**
     * 修改人
     */
    private String modifier;

    public String getRecId() {
        return recId;
    }

    public void setRecId(String recId) {
        this.recId = recId;
    }
    public Long getHospitalId() {
        return hospitalId;
    }

    public void setHospitalId(Long hospitalId) {
        this.hospitalId = hospitalId;
    }
    public String getBehospitalCode() {
        return behospitalCode;
    }

    public void setBehospitalCode(String behospitalCode) {
        this.behospitalCode = behospitalCode;
    }
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }
    public String getSex() {
        return sex;
    }

    public void setSex(String sex) {
        this.sex = sex;
    }
    public String getAge() {
        return age;
    }

    public void setAge(String age) {
        this.age = age;
    }
    public String getBedNo() {
        return bedNo;
    }

    public void setBedNo(String bedNo) {
        this.bedNo = bedNo;
    }
    public String getDeptName() {
        return deptName;
    }

    public void setDeptName(String deptName) {
        this.deptName = deptName;
    }
    public Date getRecordDate() {
        return recordDate;
    }

    public void setRecordDate(Date recordDate) {
        this.recordDate = recordDate;
    }
    public String getRecTitle() {
        return recTitle;
    }

    public void setRecTitle(String recTitle) {
        this.recTitle = recTitle;
    }
    public String getChief() {
        return chief;
    }

    public void setChief(String chief) {
        this.chief = chief;
    }
    public String getPresent() {
        return present;
    }

    public void setPresent(String present) {
        this.present = present;
    }
    public String getPastHistory() {
        return pastHistory;
    }

    public void setPastHistory(String pastHistory) {
        this.pastHistory = pastHistory;
    }
    public String getVital() {
        return vital;
    }

    public void setVital(String vital) {
        this.vital = vital;
    }
    public String getAssistantExam() {
        return assistantExam;
    }

    public void setAssistantExam(String assistantExam) {
        this.assistantExam = assistantExam;
    }
    public String getCaseCharacter() {
        return caseCharacter;
    }

    public void setCaseCharacter(String caseCharacter) {
        this.caseCharacter = caseCharacter;
    }
    public String getTentativeDiagnosis() {
        return tentativeDiagnosis;
    }

    public void setTentativeDiagnosis(String tentativeDiagnosis) {
        this.tentativeDiagnosis = tentativeDiagnosis;
    }
    public String getSupplyDiagnosis() {
        return supplyDiagnosis;
    }

    public void setSupplyDiagnosis(String supplyDiagnosis) {
        this.supplyDiagnosis = supplyDiagnosis;
    }
    public String getRevisedDiagnosis() {
        return revisedDiagnosis;
    }

    public void setRevisedDiagnosis(String revisedDiagnosis) {
        this.revisedDiagnosis = revisedDiagnosis;
    }
    public String getTreatPlan() {
        return treatPlan;
    }

    public void setTreatPlan(String treatPlan) {
        this.treatPlan = treatPlan;
    }
    public String getRecDoctor() {
        return recDoctor;
    }

    public void setRecDoctor(String recDoctor) {
        this.recDoctor = recDoctor;
    }
    public Date getRecDate() {
        return recDate;
    }

    public void setRecDate(Date recDate) {
        this.recDate = recDate;
    }
    public String getAuditDoctor() {
        return auditDoctor;
    }

    public void setAuditDoctor(String auditDoctor) {
        this.auditDoctor = auditDoctor;
    }
    public Date getAuditDate() {
        return auditDate;
    }

    public void setAuditDate(Date auditDate) {
        this.auditDate = auditDate;
    }
    public String getWholeData() {
        return wholeData;
    }

    public void setWholeData(String wholeData) {
        this.wholeData = wholeData;
    }
    public String getRemark() {
        return remark;
    }

    public void setRemark(String remark) {
        this.remark = remark;
    }
    public String getIsDeleted() {
        return isDeleted;
    }

    public void setIsDeleted(String isDeleted) {
        this.isDeleted = isDeleted;
    }
    public Date getGmtCreate() {
        return gmtCreate;
    }

    public void setGmtCreate(Date gmtCreate) {
        this.gmtCreate = gmtCreate;
    }
    public Date getGmtModified() {
        return gmtModified;
    }

    public void setGmtModified(Date gmtModified) {
        this.gmtModified = gmtModified;
    }
    public String getCreator() {
        return creator;
    }

    public void setCreator(String creator) {
        this.creator = creator;
    }
    public String getModifier() {
        return modifier;
    }

    public void setModifier(String modifier) {
        this.modifier = modifier;
    }

    @Override
    public String toString() {
        return "MedFirstRecord{" +
            "recId=" + recId +
            ", hospitalId=" + hospitalId +
            ", behospitalCode=" + behospitalCode +
            ", name=" + name +
            ", sex=" + sex +
            ", age=" + age +
            ", bedNo=" + bedNo +
            ", deptName=" + deptName +
            ", recordDate=" + recordDate +
            ", recTitle=" + recTitle +
            ", chief=" + chief +
            ", present=" + present +
            ", pastHistory=" + pastHistory +
            ", vital=" + vital +
            ", assistantExam=" + assistantExam +
            ", caseCharacter=" + caseCharacter +
            ", tentativeDiagnosis=" + tentativeDiagnosis +
            ", supplyDiagnosis=" + supplyDiagnosis +
            ", revisedDiagnosis=" + revisedDiagnosis +
            ", treatPlan=" + treatPlan +
            ", recDoctor=" + recDoctor +
            ", recDate=" + recDate +
            ", auditDoctor=" + auditDoctor +
            ", auditDate=" + auditDate +
            ", wholeData=" + wholeData +
            ", remark=" + remark +
            ", isDeleted=" + isDeleted +
            ", gmtCreate=" + gmtCreate +
            ", gmtModified=" + gmtModified +
            ", creator=" + creator +
            ", modifier=" + modifier +
        "}";
    }
}
