package com.diagbot.facade.data;

import com.alibaba.fastjson.JSON;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.generator.config.rules.NamingStrategy;
import com.diagbot.dto.data.ColumnZhAndChDTO;
import com.diagbot.entity.MedAdmissionNote;
import com.diagbot.service.impl.MedAdmissionNoteServiceImpl;
import com.diagbot.util.DateUtil;
import com.diagbot.util.EntityUtil;
import com.diagbot.util.MapUtil;
import com.diagbot.vo.data.AMedAdmissionNoteVO;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Date;
import java.util.List;
import java.util.Map;

@Component
public class AMedAdmissionNoteFacade extends MedAdmissionNoteServiceImpl {
    @Autowired
    private ColumnFacade columnFacade;
    @Autowired
    private AMedAbnormalInfoFacade aMedAbnormalInfoFacade;

    public void getColumnZhAndCh(){
        List<ColumnZhAndChDTO> list=this.baseMapper.getColumnZhAndCh();
        list.forEach(s->{
            s.setEn(NamingStrategy.underlineToCamel(s.getEn()));
        });

        Map<String, String> columnMap= EntityUtil.makeMapWithKeyValue(list,"ch","en");
        Boolean flag=columnFacade.createColumn(columnMap,"medAdmissionNote");

        //Map<String, String> map=columnFacade.getColumn("medAdmissionNote");
        if(!flag){
            return;
        }
    }

    //入院记录
    public void dealData(String columnMap,Map<String, Object> entityMap,Long hospitalId){
        try {
            AMedAdmissionNoteVO medAdmissionNoteVO=(AMedAdmissionNoteVO) MapUtil.mapToObject(entityMap, AMedAdmissionNoteVO.class);
            MedAdmissionNote medAdmissionNote=new MedAdmissionNote();
            BeanUtils.copyProperties(medAdmissionNoteVO,medAdmissionNote);
            medAdmissionNote.setHospitalId(hospitalId);//医院编码

            medAdmissionNote.setAuditDate(DateUtil.parseDateTime(medAdmissionNoteVO.getAuditDate()));//审核时间
            medAdmissionNote.setRecDate(DateUtil.parseDateTime(medAdmissionNoteVO.getRecDate()));//记录时间
            medAdmissionNote.setBehospitalDate(DateUtil.parseDateTime(medAdmissionNoteVO.getBehospitalDate()));//入院日期
            medAdmissionNote.setBirthday(DateUtil.parseDate(medAdmissionNoteVO.getBirthday()));//出生日期
            medAdmissionNote.setRecordDate(DateUtil.parseDateTime(medAdmissionNoteVO.getRecordDate()));//病历日期

            medAdmissionNote.setWholeData(columnMap);
            //判断数据库中是否存在，不存在insert
            if(isExist(medAdmissionNote)){
                medAdmissionNote.setGmtCreate(new Date());//记录创建时间
                this.save(medAdmissionNote);
            }else{
                medAdmissionNote.setGmtModified(new Date());//记录修改时间
                this.update(medAdmissionNote,new QueryWrapper<MedAdmissionNote>()
                        .eq("rec_id", medAdmissionNote.getRecId())
                        .eq("hospital_id", medAdmissionNote.getHospitalId())
                        .eq("behospital_code", medAdmissionNote.getBehospitalCode()));
            }
        }catch (Exception e){
            log.error(e.getMessage(),e);
            aMedAbnormalInfoFacade.saveAbnormalInfo("入院记录", JSON.toJSONString(entityMap),"",e.getMessage());
        }
    }

    public Boolean isExist(MedAdmissionNote medAdmissionNote){
        Boolean flag=true;
        int count = this.baseMapper.selectCount(new QueryWrapper<MedAdmissionNote>()
                .eq("rec_id", medAdmissionNote.getRecId())
                .eq("hospital_id", medAdmissionNote.getHospitalId())
                .eq("behospital_code", medAdmissionNote.getBehospitalCode()));
        if(count>0){
            flag=false;
        }
        return flag;
    }

}
