package com.diagbot.facade.data;

import com.alibaba.fastjson.JSON;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.generator.config.rules.NamingStrategy;
import com.diagbot.dto.data.ColumnZhAndChDTO;
import com.diagbot.entity.MedConsultationApply;
import com.diagbot.service.impl.MedConsultationApplyServiceImpl;
import com.diagbot.util.DateUtil;
import com.diagbot.util.EntityUtil;
import com.diagbot.util.MapUtil;
import com.diagbot.vo.data.AMedConsultationApplyVO;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Date;
import java.util.List;
import java.util.Map;

@Component
public class AMedConsultationApplyFacade extends MedConsultationApplyServiceImpl {
    @Autowired
    private ColumnFacade columnFacade;
    @Autowired
    private AMedAbnormalInfoFacade aMedAbnormalInfoFacade;

    public void getColumnZhAndCh(){
        List<ColumnZhAndChDTO> list=this.baseMapper.getColumnZhAndCh();
        list.forEach(s->{
            s.setEn(NamingStrategy.underlineToCamel(s.getEn()));
        });

        Map<String, String> columnMap= EntityUtil.makeMapWithKeyValue(list,"ch","en");
        Boolean flag=columnFacade.createColumn(columnMap,"medConsultationApply");

        //Map<String, String> map=columnFacade.getColumn("medConsultationNote");
        if(!flag){
            return;
        }
    }

    //会诊申请单
    public void dealData(String columnMap,Map<String, Object> entityMap,Long hospitalId){
        try {
            AMedConsultationApplyVO medConsultationApplyVO=(AMedConsultationApplyVO) MapUtil.mapToObject(entityMap, AMedConsultationApplyVO.class);
            MedConsultationApply medConsultationApply=new MedConsultationApply();
            BeanUtils.copyProperties(medConsultationApplyVO,medConsultationApply);
            medConsultationApply.setHospitalId(hospitalId);//医院编码

            medConsultationApply.setAuditDate(DateUtil.parseDateTime(medConsultationApplyVO.getAuditDate()));//审核时间
            medConsultationApply.setRecDate(DateUtil.parseDateTime(medConsultationApplyVO.getRecDate()));//记录时间
            medConsultationApply.setBehospitalDate(DateUtil.parseDateTime(medConsultationApplyVO.getBehospitalDate()));//入院日期
            medConsultationApply.setRecordDate(DateUtil.parseDateTime(medConsultationApplyVO.getRecordDate()));//病历日期
            medConsultationApply.setApplyDate(DateUtil.parseDateTime(medConsultationApplyVO.getApplyDate()));//申请日期
            medConsultationApply.setConsultationDate(DateUtil.parseDateTime(medConsultationApplyVO.getConsultationDate()));//会诊时间
            medConsultationApply.setWholeData(columnMap);
            //判断数据库中是否存在，不存在insert
            if(isExist(medConsultationApply)){
                medConsultationApply.setGmtCreate(new Date());//记录创建时间
                this.save(medConsultationApply);
            }else{
                medConsultationApply.setGmtModified(new Date());//记录修改时间
                this.update(medConsultationApply,new QueryWrapper<MedConsultationApply>()
                        .eq("rec_id", medConsultationApply.getRecId())
                        .eq("hospital_id", medConsultationApply.getHospitalId())
                        .eq("behospital_code", medConsultationApply.getBehospitalCode()));
            }

        }catch (Exception e){
            log.error(e.getMessage(),e);
            aMedAbnormalInfoFacade.saveAbnormalInfo("会诊申请单", JSON.toJSONString(entityMap),"",e.getMessage());
        }

    }

    public Boolean isExist(MedConsultationApply medConsultationApply){
        Boolean flag=true;
        int count = this.baseMapper.selectCount(new QueryWrapper<MedConsultationApply>()
                .eq("rec_id", medConsultationApply.getRecId())
                .eq("hospital_id", medConsultationApply.getHospitalId())
                .eq("behospital_code", medConsultationApply.getBehospitalCode()));
        if(count>0){
            flag=false;
        }
        return flag;
    }

}
