package com.diagbot.facade.data;

import com.alibaba.fastjson.JSON;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.generator.config.rules.NamingStrategy;
import com.diagbot.dto.data.ColumnZhAndChDTO;
import com.diagbot.entity.MedConsultationNote;
import com.diagbot.service.impl.MedConsultationNoteServiceImpl;
import com.diagbot.util.DateUtil;
import com.diagbot.util.EntityUtil;
import com.diagbot.util.MapUtil;
import com.diagbot.vo.data.AMedConsultationNoteVO;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Date;
import java.util.List;
import java.util.Map;

@Component
public class AMedConsultationNoteFacade extends MedConsultationNoteServiceImpl {

    @Autowired
    private ColumnFacade columnFacade;
    @Autowired
    private AMedAbnormalInfoFacade aMedAbnormalInfoFacade;

    public void getColumnZhAndCh(){
        List<ColumnZhAndChDTO> list=this.baseMapper.getColumnZhAndCh();
        list.forEach(s->{
            s.setEn(NamingStrategy.underlineToCamel(s.getEn()));
        });

        Map<String, String> columnMap=EntityUtil.makeMapWithKeyValue(list,"ch","en");
        Boolean flag=columnFacade.createColumn(columnMap,"medConsultationNote");

        //Map<String, String> map=columnFacade.getColumn("medConsultationNote");
        if(!flag){
            return;
        }
    }

    //会诊单（申请和结果）
    public void dealData(String columnMap,Map<String, Object> entityMap,Long hospitalId){
        try {
            AMedConsultationNoteVO medConsultationNoteVO=(AMedConsultationNoteVO) MapUtil.mapToObject(entityMap, AMedConsultationNoteVO.class);
            MedConsultationNote medConsultationNote=new MedConsultationNote();
            BeanUtils.copyProperties(medConsultationNoteVO,medConsultationNote);
            medConsultationNote.setHospitalId(hospitalId);//医院编码

            medConsultationNote.setAuditDate(DateUtil.parseDateTime(medConsultationNoteVO.getAuditDate()));//审核时间
            medConsultationNote.setRecDate(DateUtil.parseDateTime(medConsultationNoteVO.getRecDate()));//记录时间
            medConsultationNote.setBehospitalDate(DateUtil.parseDateTime(medConsultationNoteVO.getBehospitalDate()));//入院日期
            medConsultationNote.setApplyDate(DateUtil.parseDate(medConsultationNoteVO.getApplyDate()));//申请日期
            medConsultationNote.setRecordDate(DateUtil.parseDateTime(medConsultationNoteVO.getRecordDate()));//病历日期
            medConsultationNote.setConsultationDate(DateUtil.parseDateTime(medConsultationNoteVO.getConsultationDate()));//会诊时间

            medConsultationNote.setWholeData(columnMap);
            //判断数据库中是否存在，不存在insert
            if(isExist(medConsultationNote)){
                medConsultationNote.setGmtCreate(new Date());//记录创建时间
                this.save(medConsultationNote);
            }else{
                medConsultationNote.setGmtModified(new Date());//记录修改时间
                this.update(medConsultationNote,new QueryWrapper<MedConsultationNote>()
                        .eq("rec_id", medConsultationNote.getRecId())
                        .eq("hospital_id", medConsultationNote.getHospitalId())
                        .eq("behospital_code", medConsultationNote.getBehospitalCode()));
            }

        }catch (Exception e){
            log.error(e.getMessage(),e);
            aMedAbnormalInfoFacade.saveAbnormalInfo("会诊单（申请和结果）", JSON.toJSONString(entityMap),"",e.getMessage());
        }

    }

    public Boolean isExist(MedConsultationNote medConsultationNote){
        Boolean flag=true;
        int count = this.baseMapper.selectCount(new QueryWrapper<MedConsultationNote>()
                .eq("rec_id", medConsultationNote.getRecId())
                .eq("hospital_id", medConsultationNote.getHospitalId())
                .eq("behospital_code", medConsultationNote.getBehospitalCode()));
        if(count>0){
            flag=false;
        }
        return flag;
    }

}
