package com.diagbot.facade.data;

import com.alibaba.fastjson.JSON;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.generator.config.rules.NamingStrategy;
import com.diagbot.dto.data.ColumnZhAndChDTO;
import com.diagbot.entity.MedConsultationResult;
import com.diagbot.service.impl.MedConsultationResultServiceImpl;
import com.diagbot.util.DateUtil;
import com.diagbot.util.EntityUtil;
import com.diagbot.util.MapUtil;
import com.diagbot.vo.data.AMedConsultationResultVO;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Date;
import java.util.List;
import java.util.Map;

@Component
public class AMedConsultationResultFacade extends MedConsultationResultServiceImpl {

    @Autowired
    private ColumnFacade columnFacade;
    @Autowired
    private AMedAbnormalInfoFacade aMedAbnormalInfoFacade;

    public void getColumnZhAndCh(){
        List<ColumnZhAndChDTO> list=this.baseMapper.getColumnZhAndCh();
        list.forEach(s->{
            s.setEn(NamingStrategy.underlineToCamel(s.getEn()));
        });

        Map<String, String> columnMap= EntityUtil.makeMapWithKeyValue(list,"ch","en");
        Boolean flag=columnFacade.createColumn(columnMap,"medConsultationResult");

        //Map<String, String> map=columnFacade.getColumn("medConsultationNote");
        if(!flag){
            return;
        }
    }

    //会诊结果单
    public void dealData(String columnMap,Map<String, Object> entityMap,Long hospitalId){
        try {
            AMedConsultationResultVO medConsultationResultVO=(AMedConsultationResultVO) MapUtil.mapToObject(entityMap, AMedConsultationResultVO.class);
            MedConsultationResult medConsultationResult=new MedConsultationResult();
            BeanUtils.copyProperties(medConsultationResultVO,medConsultationResult);
            medConsultationResult.setHospitalId(hospitalId);//医院编码

            medConsultationResult.setAuditDate(DateUtil.parseDateTime(medConsultationResultVO.getAuditDate()));//审核时间
            medConsultationResult.setRecDate(DateUtil.parseDateTime(medConsultationResultVO.getRecDate()));//记录时间
            medConsultationResult.setBehospitalDate(DateUtil.parseDateTime(medConsultationResultVO.getBehospitalDate()));//入院日期
            medConsultationResult.setApplyDate(DateUtil.parseDate(medConsultationResultVO.getApplyDate()));//申请时间
            medConsultationResult.setRecordDate(DateUtil.parseDateTime(medConsultationResultVO.getRecordDate()));//病历日期
            medConsultationResult.setConsultationArriveDate(DateUtil.parseDateTime(medConsultationResultVO.getConsultationArriveDate()));//会诊到达时间

            medConsultationResult.setWholeData(columnMap);
            //判断数据库中是否存在，不存在insert
            if(isExist(medConsultationResult)){
                medConsultationResult.setGmtCreate(new Date());//记录创建时间
                this.save(medConsultationResult);
            }else{
                medConsultationResult.setGmtModified(new Date());//记录修改时间
                this.update(medConsultationResult,new QueryWrapper<MedConsultationResult>()
                        .eq("rec_id", medConsultationResult.getRecId())
                        .eq("hospital_id", medConsultationResult.getHospitalId())
                        .eq("behospital_code", medConsultationResult.getBehospitalCode()));
            }

        }catch (Exception e){
            log.error(e.getMessage(),e);
            aMedAbnormalInfoFacade.saveAbnormalInfo("会诊结果单", JSON.toJSONString(entityMap),"",e.getMessage());
        }

    }

    public Boolean isExist(MedConsultationResult medConsultationResult){
        Boolean flag=true;
        int count = this.baseMapper.selectCount(new QueryWrapper<MedConsultationResult>()
                .eq("rec_id", medConsultationResult.getRecId())
                .eq("hospital_id", medConsultationResult.getHospitalId())
                .eq("behospital_code", medConsultationResult.getBehospitalCode()));
        if(count>0){
            flag=false;
        }
        return flag;
    }
}
