package com.diagbot.facade.data;

import com.alibaba.fastjson.JSON;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.generator.config.rules.NamingStrategy;
import com.diagbot.dto.data.ColumnZhAndChDTO;
import com.diagbot.entity.MedCrisisNote;
import com.diagbot.service.impl.MedCrisisNoteServiceImpl;
import com.diagbot.util.DateUtil;
import com.diagbot.util.EntityUtil;
import com.diagbot.util.MapUtil;
import com.diagbot.vo.data.AMedCrisisNoteVO;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Date;
import java.util.List;
import java.util.Map;

@Component
public class AMedCrisisNoteFacade extends MedCrisisNoteServiceImpl {
    @Autowired
    private ColumnFacade columnFacade;
    @Autowired
    private AMedAbnormalInfoFacade aMedAbnormalInfoFacade;

    public void getColumnZhAndCh(){
        List<ColumnZhAndChDTO> list=this.baseMapper.getColumnZhAndCh();
        list.forEach(s->{
            s.setEn(NamingStrategy.underlineToCamel(s.getEn()));
        });

        Map<String, String> columnMap= EntityUtil.makeMapWithKeyValue(list,"ch","en");
        Boolean flag=columnFacade.createColumn(columnMap,"medCrisisNote");
        if(!flag){
            return;
        }
    }

    public void dealData(String columnMap,Map<String, Object> entityMap,Long hospitalId){
        try {
            AMedCrisisNoteVO medCrisisNoteVO=(AMedCrisisNoteVO) MapUtil.mapToObject(entityMap, AMedCrisisNoteVO.class);
            MedCrisisNote medCrisisNote=new MedCrisisNote();
            BeanUtils.copyProperties(medCrisisNoteVO,medCrisisNote);
            medCrisisNote.setHospitalId(hospitalId);//医院编码

            medCrisisNote.setAuditDate(DateUtil.parseDateTime(medCrisisNoteVO.getAuditDate()));//审核时间
            medCrisisNote.setRecDate(DateUtil.parseDateTime(medCrisisNoteVO.getRecDate()));//记录时间
            medCrisisNote.setRecieveDate(DateUtil.parseDateTime(medCrisisNoteVO.getRecieveDate()));//开始时间
            medCrisisNote.setAuditDate(DateUtil.parseDate(medCrisisNoteVO.getAuditDate()));//结束时间
            medCrisisNote.setRecordDate(DateUtil.parseDateTime(medCrisisNoteVO.getRecordDate()));//病历日期

            medCrisisNote.setWholeData(columnMap);
            //判断数据库中是否存在，不存在insert
            if(isExist(medCrisisNote)){
                medCrisisNote.setGmtCreate(new Date());//记录创建时间
                this.save(medCrisisNote);
            }else{
                medCrisisNote.setGmtModified(new Date());//记录修改时间
                this.update(medCrisisNote,new QueryWrapper<MedCrisisNote>()
                        .eq("rec_id", medCrisisNote.getRecId())
                        .eq("hospital_id", medCrisisNote.getHospitalId())
                        .eq("behospital_code", medCrisisNote.getBehospitalCode()));
            }

        }catch (Exception e){
            log.error(e.getMessage(),e);
            aMedAbnormalInfoFacade.saveAbnormalInfo("危急值记录", JSON.toJSONString(entityMap),"",e.getMessage());
        }

    }

    public Boolean isExist(MedCrisisNote medCrisisNote){
        Boolean flag=true;
        int count = this.baseMapper.selectCount(new QueryWrapper<MedCrisisNote>()
                .eq("rec_id", medCrisisNote.getRecId())
                .eq("hospital_id", medCrisisNote.getHospitalId())
                .eq("behospital_code", medCrisisNote.getBehospitalCode()));
        if(count>0){
            flag=false;
        }
        return flag;
    }
}
