package com.diagbot.facade.data;

import com.alibaba.fastjson.JSON;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.generator.config.rules.NamingStrategy;
import com.diagbot.dto.data.ColumnZhAndChDTO;
import com.diagbot.entity.MedDeathNote;
import com.diagbot.service.impl.MedDeathNoteServiceImpl;
import com.diagbot.util.DateUtil;
import com.diagbot.util.EntityUtil;
import com.diagbot.util.MapUtil;
import com.diagbot.vo.data.AMedDeathNoteVO;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Date;
import java.util.List;
import java.util.Map;

@Component
public class AMedDeathNoteFacade extends MedDeathNoteServiceImpl {
    @Autowired
    private ColumnFacade columnFacade;
    @Autowired
    private AMedAbnormalInfoFacade aMedAbnormalInfoFacade;

    public void getColumnZhAndCh(){
        List<ColumnZhAndChDTO> list=this.baseMapper.getColumnZhAndCh();
        list.forEach(s->{
            s.setEn(NamingStrategy.underlineToCamel(s.getEn()));
        });

        Map<String, String> columnMap= EntityUtil.makeMapWithKeyValue(list,"ch","en");
        Boolean flag=columnFacade.createColumn(columnMap,"medDeathNote");

        //Map<String, String> map=columnFacade.getColumn("medConsultationNote");
        if(!flag){
            return;
        }
    }

    //死亡记录
    public void dealData(String columnMap,Map<String, Object> entityMap,Long hospitalId){
        try {
            AMedDeathNoteVO medDeathNoteVO=(AMedDeathNoteVO) MapUtil.mapToObject(entityMap, AMedDeathNoteVO.class);
            MedDeathNote medDeathNote=new MedDeathNote();
            BeanUtils.copyProperties(medDeathNoteVO,medDeathNote);
            medDeathNote.setHospitalId(hospitalId);//医院编码

            medDeathNote.setAuditDate(DateUtil.parseDateTime(medDeathNoteVO.getAuditDate()));//审核时间
            medDeathNote.setRecDate(DateUtil.parseDateTime(medDeathNoteVO.getRecDate()));//记录时间
            medDeathNote.setBehospitalDate(DateUtil.parseDateTime(medDeathNoteVO.getBehospitalDate()));//入院日期
            medDeathNote.setDeathDate(DateUtil.parseDate(medDeathNoteVO.getDeathDate()));//死亡日期
            medDeathNote.setRecordDate(DateUtil.parseDateTime(medDeathNoteVO.getRecordDate()));//病历日期

            medDeathNote.setWholeData(columnMap);
            //判断数据库中是否存在，不存在insert
            if(isExist(medDeathNote)){
                medDeathNote.setGmtCreate(new Date());//记录创建时间
                this.save(medDeathNote);
            }else{
                medDeathNote.setGmtModified(new Date());//记录修改时间
                this.update(medDeathNote,new QueryWrapper<MedDeathNote>()
                        .eq("rec_id", medDeathNote.getRecId())
                        .eq("hospital_id", medDeathNote.getHospitalId())
                        .eq("behospital_code", medDeathNote.getBehospitalCode()));
            }

        }catch (Exception e){
            log.error(e.getMessage(),e);
            aMedAbnormalInfoFacade.saveAbnormalInfo("死亡记录", JSON.toJSONString(entityMap),"",e.getMessage());
        }

    }

    public Boolean isExist(MedDeathNote medDeathNote){
        Boolean flag=true;
        int count = this.baseMapper.selectCount(new QueryWrapper<MedDeathNote>()
                .eq("rec_id", medDeathNote.getRecId())
                .eq("hospital_id", medDeathNote.getHospitalId())
                .eq("behospital_code", medDeathNote.getBehospitalCode()));
        if(count>0){
            flag=false;
        }
        return flag;
    }
}
