package com.diagbot.facade.data;

import com.alibaba.fastjson.JSON;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.generator.config.rules.NamingStrategy;
import com.diagbot.dto.data.ColumnZhAndChDTO;
import com.diagbot.entity.MedFirstRecord;
import com.diagbot.service.impl.MedFirstRecordServiceImpl;
import com.diagbot.util.DateUtil;
import com.diagbot.util.EntityUtil;
import com.diagbot.util.MapUtil;
import com.diagbot.vo.data.AMedFirstRecordVO;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Date;
import java.util.List;
import java.util.Map;

@Component
public class AMedFirstRecordFacade extends MedFirstRecordServiceImpl {

    @Autowired
    private ColumnFacade columnFacade;
    @Autowired
    private AMedAbnormalInfoFacade aMedAbnormalInfoFacade;

    public void getColumnZhAndCh(){
        List<ColumnZhAndChDTO> list=this.baseMapper.getColumnZhAndCh();
        list.forEach(s->{
            s.setEn(NamingStrategy.underlineToCamel(s.getEn()));
        });

        Map<String, String> columnMap= EntityUtil.makeMapWithKeyValue(list,"ch","en");
        Boolean flag=columnFacade.createColumn(columnMap,"medFirstRecord");

        //Map<String, String> map=columnFacade.getColumn("medConsultationNote");
        if(!flag){
            return;
        }
    }

    public void dealData(String columnMap,Map<String, Object> entityMap,Long hospitalId){
        try {
            AMedFirstRecordVO medFirstRecordVO=(AMedFirstRecordVO) MapUtil.mapToObject(entityMap, AMedFirstRecordVO.class);
            MedFirstRecord medFirstRecord=new MedFirstRecord();
            BeanUtils.copyProperties(medFirstRecordVO,medFirstRecord);
            medFirstRecord.setHospitalId(hospitalId);//医院编码

            medFirstRecord.setAuditDate(DateUtil.parseDateTime(medFirstRecordVO.getAuditDate()));//审核时间
            medFirstRecord.setRecDate(DateUtil.parseDateTime(medFirstRecordVO.getRecDate()));//记录时间
            medFirstRecord.setRecordDate(DateUtil.parseDateTime(medFirstRecordVO.getRecordDate()));//病历日期

            medFirstRecord.setWholeData(columnMap);
            //判断数据库中是否存在，不存在insert
            if(isExist(medFirstRecord)){
                medFirstRecord.setGmtCreate(new Date());//记录创建时间
                this.save(medFirstRecord);
            }else{
                medFirstRecord.setGmtModified(new Date());//记录修改时间
                this.update(medFirstRecord,new QueryWrapper<MedFirstRecord>()
                        .eq("rec_id", medFirstRecord.getRecId())
                        .eq("hospital_id", medFirstRecord.getHospitalId())
                        .eq("behospital_code", medFirstRecord.getBehospitalCode()));
            }

        }catch (Exception e){
            log.error(e.getMessage(),e);
            aMedAbnormalInfoFacade.saveAbnormalInfo("首次病程录", JSON.toJSONString(entityMap),"",e.getMessage());
        }

    }

    public Boolean isExist(MedFirstRecord medFirstRecord){
        Boolean flag=true;
        int count = this.baseMapper.selectCount(new QueryWrapper<MedFirstRecord>()
                .eq("rec_id", medFirstRecord.getRecId())
                .eq("hospital_id", medFirstRecord.getHospitalId())
                .eq("behospital_code", medFirstRecord.getBehospitalCode()));
        if(count>0){
            flag=false;
        }
        return flag;
    }
}
