package com.diagbot.facade.data;

import com.alibaba.fastjson.JSON;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.generator.config.rules.NamingStrategy;
import com.diagbot.dto.data.ColumnZhAndChDTO;
import com.diagbot.entity.MedLeaveHospital;
import com.diagbot.service.impl.MedLeaveHospitalServiceImpl;
import com.diagbot.util.DateUtil;
import com.diagbot.util.EntityUtil;
import com.diagbot.util.MapUtil;
import com.diagbot.vo.data.AMedLeaveHospitalVO;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Date;
import java.util.List;
import java.util.Map;

@Component
public class AMedLeaveHospitalFacade extends MedLeaveHospitalServiceImpl {
    @Autowired
    private ColumnFacade columnFacade;
    @Autowired
    private AMedAbnormalInfoFacade aMedAbnormalInfoFacade;

    public void getColumnZhAndCh(){
        List<ColumnZhAndChDTO> list=this.baseMapper.getColumnZhAndCh();
        list.forEach(s->{
            s.setEn(NamingStrategy.underlineToCamel(s.getEn()));
        });

        Map<String, String> columnMap= EntityUtil.makeMapWithKeyValue(list,"ch","en");
        Boolean flag=columnFacade.createColumn(columnMap,"medLeaveHospital");

        //Map<String, String> map=columnFacade.getColumn("medConsultationNote");
        if(!flag){
            return;
        }
    }

    //危急值记录
    public void dealData(String columnMap,Map<String, Object> entityMap,Long hospitalId){
        try {
            AMedLeaveHospitalVO medLeaveHospitalVO=(AMedLeaveHospitalVO) MapUtil.mapToObject(entityMap, AMedLeaveHospitalVO.class);
            MedLeaveHospital medLeaveHospital=new MedLeaveHospital();
            BeanUtils.copyProperties(medLeaveHospitalVO,medLeaveHospital);
            medLeaveHospital.setHospitalId(hospitalId);//医院编码

            medLeaveHospital.setAuditDate(DateUtil.parseDateTime(medLeaveHospitalVO.getAuditDate()));//审核时间
            medLeaveHospital.setRecDate(DateUtil.parseDateTime(medLeaveHospitalVO.getRecDate()));//记录时间
            medLeaveHospital.setBehospitalDate(DateUtil.parseDateTime(medLeaveHospitalVO.getBehospitalDate()));//入院日期
            medLeaveHospital.setLeaveHospitalDate(DateUtil.parseDateTime(medLeaveHospitalVO.getLeaveHospitalDate()));//出院时间
            medLeaveHospital.setRecordDate(DateUtil.parseDateTime(medLeaveHospitalVO.getRecordDate()));//病历日期

            medLeaveHospital.setWholeData(columnMap);
            //判断数据库中是否存在，不存在insert
            if(isExist(medLeaveHospital)){
                medLeaveHospital.setGmtCreate(new Date());//记录创建时间
                this.save(medLeaveHospital);
            }else{
                medLeaveHospital.setGmtModified(new Date());//记录修改时间
                this.update(medLeaveHospital,new QueryWrapper<MedLeaveHospital>()
                        .eq("rec_id", medLeaveHospital.getRecId())
                        .eq("hospital_id", medLeaveHospital.getHospitalId())
                        .eq("behospital_code", medLeaveHospital.getBehospitalCode()));
            }

        }catch (Exception e){
            log.error(e.getMessage(),e);
            aMedAbnormalInfoFacade.saveAbnormalInfo("出院小结", JSON.toJSONString(entityMap),"",e.getMessage());
        }

    }

    public Boolean isExist(MedLeaveHospital medLeaveHospital){
        Boolean flag=true;
        int count = this.baseMapper.selectCount(new QueryWrapper<MedLeaveHospital>()
                .eq("rec_id", medLeaveHospital.getRecId())
                .eq("hospital_id", medLeaveHospital.getHospitalId())
                .eq("behospital_code", medLeaveHospital.getBehospitalCode()));
        if(count>0){
            flag=false;
        }
        return flag;
    }
}
