package com.diagbot.facade.data;

import com.alibaba.fastjson.JSON;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.generator.config.rules.NamingStrategy;
import com.diagbot.dto.data.ColumnZhAndChDTO;
import com.diagbot.entity.MedOperativeFirstRecord;
import com.diagbot.service.impl.MedOperativeFirstRecordServiceImpl;
import com.diagbot.util.DateUtil;
import com.diagbot.util.EntityUtil;
import com.diagbot.util.MapUtil;
import com.diagbot.vo.data.AMedOperativeFirstRecordVO;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Date;
import java.util.List;
import java.util.Map;

@Component
public class AMedOperativeFirstRecord extends MedOperativeFirstRecordServiceImpl {

    @Autowired
    private ColumnFacade columnFacade;
    @Autowired
    private AMedAbnormalInfoFacade aMedAbnormalInfoFacade;

    public void getColumnZhAndCh(){
        List<ColumnZhAndChDTO> list=this.baseMapper.getColumnZhAndCh();
        list.forEach(s->{
            s.setEn(NamingStrategy.underlineToCamel(s.getEn()));
        });

        Map<String, String> columnMap= EntityUtil.makeMapWithKeyValue(list,"ch","en");
        Boolean flag=columnFacade.createColumn(columnMap,"medOperativeFirstRecord");

        //Map<String, String> map=columnFacade.getColumn("medConsultationNote");
        if(!flag){
            return;
        }
    }

    //术后首程
    public void dealData(String columnMap,Map<String, Object> entityMap,Long hospitalId){
        try {
            AMedOperativeFirstRecordVO medOperativeFirstRecordVO=(AMedOperativeFirstRecordVO) MapUtil.mapToObject(entityMap, AMedOperativeFirstRecordVO.class);
            MedOperativeFirstRecord medOperativeFirstRecord=new MedOperativeFirstRecord();
            BeanUtils.copyProperties(medOperativeFirstRecordVO,medOperativeFirstRecord);
            medOperativeFirstRecord.setHospitalId(hospitalId);//医院编码

            medOperativeFirstRecord.setAuditDate(DateUtil.parseDateTime(medOperativeFirstRecordVO.getAuditDate()));//审核时间
            medOperativeFirstRecord.setRecDate(DateUtil.parseDateTime(medOperativeFirstRecordVO.getRecDate()));//记录时间
            medOperativeFirstRecord.setOperationDate(DateUtil.parseDateTime(medOperativeFirstRecordVO.getOperationDate()));//手术日期
            medOperativeFirstRecord.setStartTime(DateUtil.parseDate(medOperativeFirstRecordVO.getStartTime()));//开始时间
            medOperativeFirstRecord.setEndTime(DateUtil.parseDate(medOperativeFirstRecordVO.getEndTime()));//结束时间
            medOperativeFirstRecord.setRecordDate(DateUtil.parseDateTime(medOperativeFirstRecordVO.getRecordDate()));//病历日期

            medOperativeFirstRecord.setWholeData(columnMap);
            //判断数据库中是否存在，不存在insert
            if(isExist(medOperativeFirstRecord)){
                medOperativeFirstRecord.setGmtCreate(new Date());//记录创建时间
                this.save(medOperativeFirstRecord);
            }else{
                medOperativeFirstRecord.setGmtModified(new Date());//记录修改时间
                this.update(medOperativeFirstRecord,new QueryWrapper<MedOperativeFirstRecord>()
                        .eq("rec_id", medOperativeFirstRecord.getRecId())
                        .eq("hospital_id", medOperativeFirstRecord.getHospitalId())
                        .eq("behospital_code", medOperativeFirstRecord.getBehospitalCode()));
            }

        }catch (Exception e){
            log.error(e.getMessage(),e);
            aMedAbnormalInfoFacade.saveAbnormalInfo("术后首程", JSON.toJSONString(entityMap),"",e.getMessage());
        }

    }

    public Boolean isExist(MedOperativeFirstRecord medOperativeFirstRecord){
        Boolean flag=true;
        int count = this.baseMapper.selectCount(new QueryWrapper<MedOperativeFirstRecord>()
                .eq("rec_id", medOperativeFirstRecord.getRecId())
                .eq("hospital_id", medOperativeFirstRecord.getHospitalId())
                .eq("behospital_code", medOperativeFirstRecord.getBehospitalCode()));
        if(count>0){
            flag=false;
        }
        return flag;
    }
}
