package com.diagbot.facade.data;

import com.alibaba.fastjson.JSON;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.generator.config.rules.NamingStrategy;
import com.diagbot.dto.data.ColumnZhAndChDTO;
import com.diagbot.entity.MedOperativeNote;
import com.diagbot.service.impl.MedOperativeNoteServiceImpl;
import com.diagbot.util.DateUtil;
import com.diagbot.util.EntityUtil;
import com.diagbot.util.MapUtil;
import com.diagbot.vo.data.AMedOperativeNoteVO;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Date;
import java.util.List;
import java.util.Map;

@Component
public class AMedOperativeNoteFacade extends MedOperativeNoteServiceImpl {
    @Autowired
    private ColumnFacade columnFacade;
    @Autowired
    private AMedAbnormalInfoFacade aMedAbnormalInfoFacade;

    public void getColumnZhAndCh(){
        List<ColumnZhAndChDTO> list=this.baseMapper.getColumnZhAndCh();
        list.forEach(s->{
            s.setEn(NamingStrategy.underlineToCamel(s.getEn()));
        });

        Map<String, String> columnMap= EntityUtil.makeMapWithKeyValue(list,"ch","en");
        Boolean flag=columnFacade.createColumn(columnMap,"medOperativeNote");

        //Map<String, String> map=columnFacade.getColumn("medConsultationNote");
        if(!flag){
            return;
        }
    }

    //手术记录
    public void dealData(String columnMap,Map<String, Object> entityMap,Long hospitalId){
        try {
            AMedOperativeNoteVO medOperativeNoteVO=(AMedOperativeNoteVO) MapUtil.mapToObject(entityMap, AMedOperativeNoteVO.class);
            MedOperativeNote medOperativeNote=new MedOperativeNote();
            BeanUtils.copyProperties(medOperativeNoteVO,medOperativeNote);
            medOperativeNote.setHospitalId(hospitalId);//医院编码

            medOperativeNote.setAuditDate(DateUtil.parseDateTime(medOperativeNoteVO.getAuditDate()));//审核时间
            medOperativeNote.setRecDate(DateUtil.parseDateTime(medOperativeNoteVO.getRecDate()));//记录时间
            medOperativeNote.setOperationDate(DateUtil.parseDateTime(medOperativeNoteVO.getOperationDate()));//手术日期
            medOperativeNote.setStartTime(DateUtil.parseDate(medOperativeNoteVO.getStartTime()));//开始时间
            medOperativeNote.setEndTime(DateUtil.parseDate(medOperativeNoteVO.getEndTime()));//结束时间
            medOperativeNote.setRecordDate(DateUtil.parseDateTime(medOperativeNoteVO.getRecordDate()));//病历日期

            medOperativeNote.setWholeData(columnMap);
            //判断数据库中是否存在，不存在insert
            if(isExist(medOperativeNote)){
                medOperativeNote.setGmtCreate(new Date());//记录创建时间
                this.save(medOperativeNote);
            }else{
                medOperativeNote.setGmtModified(new Date());//记录修改时间
                this.update(medOperativeNote,new QueryWrapper<MedOperativeNote>()
                        .eq("rec_id", medOperativeNote.getRecId())
                        .eq("hospital_id", medOperativeNote.getHospitalId())
                        .eq("behospital_code", medOperativeNote.getBehospitalCode()));
            }

        }catch (Exception e){
            log.error(e.getMessage(),e);
            aMedAbnormalInfoFacade.saveAbnormalInfo("手术记录", JSON.toJSONString(entityMap),"",e.getMessage());
        }

    }

    public Boolean isExist(MedOperativeNote medOperativeNote){
        Boolean flag=true;
        int count = this.baseMapper.selectCount(new QueryWrapper<MedOperativeNote>()
                .eq("rec_id", medOperativeNote.getRecId())
                .eq("hospital_id", medOperativeNote.getHospitalId())
                .eq("behospital_code", medOperativeNote.getBehospitalCode()));
        if(count>0){
            flag=false;
        }
        return flag;
    }
}
