package com.diagbot.facade.data;

import com.alibaba.fastjson.JSON;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.generator.config.rules.NamingStrategy;
import com.diagbot.dto.data.ColumnZhAndChDTO;
import com.diagbot.entity.MedPeriodConclusion;
import com.diagbot.service.impl.MedPeriodConclusionServiceImpl;
import com.diagbot.util.DateUtil;
import com.diagbot.util.EntityUtil;
import com.diagbot.util.MapUtil;
import com.diagbot.vo.data.AMedAdmissionNoteVO;
import com.diagbot.vo.data.AMedPeriodConclusionVO;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Date;
import java.util.List;
import java.util.Map;

@Component
public class AMedPeriodConclusionFacade extends MedPeriodConclusionServiceImpl {

    @Autowired
    private ColumnFacade columnFacade;
    @Autowired
    private AMedAbnormalInfoFacade aMedAbnormalInfoFacade;

    public void getColumnZhAndCh(){
        List<ColumnZhAndChDTO> list=this.baseMapper.getColumnZhAndCh();
        list.forEach(s->{
            s.setEn(NamingStrategy.underlineToCamel(s.getEn()));
        });

        Map<String, String> columnMap= EntityUtil.makeMapWithKeyValue(list,"ch","en");
        Boolean flag=columnFacade.createColumn(columnMap,"medPeriodConclusion");

        //Map<String, String> map=columnFacade.getColumn("medConsultationNote");
        if(!flag){
            return;
        }
    }

    public void dealData(String columnMap,Map<String, Object> entityMap,Long hospitalId){
        try {
            AMedPeriodConclusionVO medPeriodConclusionVO=(AMedPeriodConclusionVO) MapUtil.mapToObject(entityMap, AMedAdmissionNoteVO.class);
            MedPeriodConclusion medPeriodConclusion=new MedPeriodConclusion();
            BeanUtils.copyProperties(medPeriodConclusionVO,medPeriodConclusion);
            medPeriodConclusion.setHospitalId(hospitalId);//医院编码

            medPeriodConclusion.setAuditDate(DateUtil.parseDateTime(medPeriodConclusionVO.getAuditDate()));//审核时间
            medPeriodConclusion.setRecDate(DateUtil.parseDateTime(medPeriodConclusionVO.getRecDate()));//记录时间
            medPeriodConclusion.setRecordDate(DateUtil.parseDateTime(medPeriodConclusionVO.getRecordDate()));//病历日期

            medPeriodConclusion.setWholeData(columnMap);
            //判断数据库中是否存在，不存在insert
            if(isExist(medPeriodConclusion)){
                medPeriodConclusion.setGmtCreate(new Date());//记录创建时间
                this.save(medPeriodConclusion);
            }else{
                medPeriodConclusion.setGmtModified(new Date());//记录修改时间
                this.update(medPeriodConclusion,new QueryWrapper<MedPeriodConclusion>()
                        .eq("rec_id", medPeriodConclusion.getRecId())
                        .eq("hospital_id", medPeriodConclusion.getHospitalId())
                        .eq("behospital_code", medPeriodConclusion.getBehospitalCode()));
            }

        }catch (Exception e){
            log.error(e.getMessage(),e);
            aMedAbnormalInfoFacade.saveAbnormalInfo("阶段小结", JSON.toJSONString(entityMap),"",e.getMessage());
        }

    }

    public Boolean isExist(MedPeriodConclusion medPeriodConclusion){
        Boolean flag=true;
        int count = this.baseMapper.selectCount(new QueryWrapper<MedPeriodConclusion>()
                .eq("rec_id", medPeriodConclusion.getRecId())
                .eq("hospital_id", medPeriodConclusion.getHospitalId())
                .eq("behospital_code", medPeriodConclusion.getBehospitalCode()));
        if(count>0){
            flag=false;
        }
        return flag;
    }

}
