package com.diagbot.facade.data;

import com.alibaba.fastjson.JSON;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.generator.config.rules.NamingStrategy;
import com.diagbot.dto.data.ColumnZhAndChDTO;
import com.diagbot.entity.MedPreoperativeDiscussion;
import com.diagbot.service.impl.MedPreoperativeDiscussionServiceImpl;
import com.diagbot.util.DateUtil;
import com.diagbot.util.EntityUtil;
import com.diagbot.util.MapUtil;
import com.diagbot.vo.data.AMedPreoperativeDiscussionVO;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Date;
import java.util.List;
import java.util.Map;

@Component
public class AMedPreoperativeDiscussionFacade extends MedPreoperativeDiscussionServiceImpl {
    @Autowired
    private ColumnFacade columnFacade;
    @Autowired
    private AMedAbnormalInfoFacade aMedAbnormalInfoFacade;

    public void getColumnZhAndCh(){
        List<ColumnZhAndChDTO> list=this.baseMapper.getColumnZhAndCh();
        list.forEach(s->{
            s.setEn(NamingStrategy.underlineToCamel(s.getEn()));
        });

        Map<String, String> columnMap= EntityUtil.makeMapWithKeyValue(list,"ch","en");
        Boolean flag=columnFacade.createColumn(columnMap,"medPreoperativeDiscussion");

        //Map<String, String> map=columnFacade.getColumn("medConsultationNote");
        if(!flag){
            return;
        }
    }

    //入院记录
    public void dealData(String columnMap,Map<String, Object> entityMap,Long hospitalId){
        try {
            AMedPreoperativeDiscussionVO medPreoperativeDiscussionVO=(AMedPreoperativeDiscussionVO) MapUtil.mapToObject(entityMap, AMedPreoperativeDiscussionVO.class);
            MedPreoperativeDiscussion medPreoperativeDiscussion=new MedPreoperativeDiscussion();
            BeanUtils.copyProperties(medPreoperativeDiscussionVO,medPreoperativeDiscussion);
            medPreoperativeDiscussion.setHospitalId(hospitalId);//医院编码

            medPreoperativeDiscussion.setAuditDate(DateUtil.parseDateTime(medPreoperativeDiscussionVO.getAuditDate()));//审核时间
            medPreoperativeDiscussion.setRecDate(DateUtil.parseDateTime(medPreoperativeDiscussionVO.getRecDate()));//记录时间
            medPreoperativeDiscussion.setDiscussTime(DateUtil.parseDateTime(medPreoperativeDiscussionVO.getDiscussTime()));//讨论时间
            medPreoperativeDiscussion.setRecordDate(DateUtil.parseDateTime(medPreoperativeDiscussionVO.getRecordDate()));//病历日期

            medPreoperativeDiscussion.setWholeData(columnMap);
            //判断数据库中是否存在，不存在insert
            if(isExist(medPreoperativeDiscussion)){
                medPreoperativeDiscussion.setGmtCreate(new Date());//记录创建时间
                this.save(medPreoperativeDiscussion);
            }else{
                medPreoperativeDiscussion.setGmtModified(new Date());//记录修改时间
                this.update(medPreoperativeDiscussion,new QueryWrapper<MedPreoperativeDiscussion>()
                        .eq("rec_id", medPreoperativeDiscussion.getRecId())
                        .eq("hospital_id", medPreoperativeDiscussion.getHospitalId())
                        .eq("behospital_code", medPreoperativeDiscussion.getBehospitalCode()));
            }

        }catch (Exception e){
            log.error(e.getMessage(),e);
            aMedAbnormalInfoFacade.saveAbnormalInfo("术前讨论小结", JSON.toJSONString(entityMap),"",e.getMessage());
        }

    }

    public Boolean isExist(MedPreoperativeDiscussion medPreoperativeDiscussion){
        Boolean flag=true;
        int count = this.baseMapper.selectCount(new QueryWrapper<MedPreoperativeDiscussion>()
                .eq("rec_id", medPreoperativeDiscussion.getRecId())
                .eq("hospital_id", medPreoperativeDiscussion.getHospitalId())
                .eq("behospital_code", medPreoperativeDiscussion.getBehospitalCode()));
        if(count>0){
            flag=false;
        }
        return flag;
    }
}
