package com.diagbot.facade.data;

import com.alibaba.fastjson.JSON;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.generator.config.rules.NamingStrategy;
import com.diagbot.dto.data.ColumnZhAndChDTO;
import com.diagbot.entity.MedTransferInNote;
import com.diagbot.service.impl.MedTransferInNoteServiceImpl;
import com.diagbot.util.DateUtil;
import com.diagbot.util.EntityUtil;
import com.diagbot.util.MapUtil;
import com.diagbot.vo.data.AMedTransferInNoteVO;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Date;
import java.util.List;
import java.util.Map;

@Component
public class AMedTransferInNoteFacade extends MedTransferInNoteServiceImpl {

    @Autowired
    private ColumnFacade columnFacade;
    @Autowired
    private AMedAbnormalInfoFacade aMedAbnormalInfoFacade;

    public void getColumnZhAndCh(){
        List<ColumnZhAndChDTO> list=this.baseMapper.getColumnZhAndCh();
        list.forEach(s->{
            s.setEn(NamingStrategy.underlineToCamel(s.getEn()));
        });

        Map<String, String> columnMap= EntityUtil.makeMapWithKeyValue(list,"ch","en");
        Boolean flag=columnFacade.createColumn(columnMap,"medTransferInNote");

        //Map<String, String> map=columnFacade.getColumn("medConsultationNote");
        if(!flag){
            return;
        }
    }

    public void dealData(String columnMap,Map<String, Object> entityMap,Long hospitalId){
        try {
            AMedTransferInNoteVO medTransferInNoteVO=(AMedTransferInNoteVO) MapUtil.mapToObject(entityMap, AMedTransferInNoteVO.class);
            MedTransferInNote medTransferInNote=new MedTransferInNote();
            BeanUtils.copyProperties(medTransferInNoteVO,medTransferInNote);
            medTransferInNote.setHospitalId(hospitalId);//医院编码
            medTransferInNote.setTransferInDate(DateUtil.parseDateTime(medTransferInNoteVO.getTransferInDate()));
            medTransferInNote.setAuditDate(DateUtil.parseDateTime(medTransferInNoteVO.getAuditDate()));//审核时间
            medTransferInNote.setRecDate(DateUtil.parseDateTime(medTransferInNoteVO.getRecDate()));//记录时间
            medTransferInNote.setRecordDate(DateUtil.parseDateTime(medTransferInNoteVO.getRecordDate()));//病历日期

            medTransferInNote.setWholeData(columnMap);
            //判断数据库中是否存在，不存在insert
            if(isExist(medTransferInNote)){
                medTransferInNote.setGmtCreate(new Date());//记录创建时间
                this.save(medTransferInNote);
            }else{
                medTransferInNote.setGmtModified(new Date());//记录修改时间
                this.update(medTransferInNote,new QueryWrapper<MedTransferInNote>()
                        .eq("rec_id", medTransferInNote.getRecId())
                        .eq("hospital_id", medTransferInNote.getHospitalId())
                        .eq("behospital_code", medTransferInNote.getBehospitalCode()));
            }

        }catch (Exception e){
            log.error(e.getMessage(),e);
            aMedAbnormalInfoFacade.saveAbnormalInfo("转入记录", JSON.toJSONString(entityMap),"",e.getMessage());
        }

    }

    public Boolean isExist(MedTransferInNote medTransferInNote){
        Boolean flag=true;
        int count = this.baseMapper.selectCount(new QueryWrapper<MedTransferInNote>()
                .eq("rec_id", medTransferInNote.getRecId())
                .eq("hospital_id", medTransferInNote.getHospitalId())
                .eq("behospital_code", medTransferInNote.getBehospitalCode()));
        if(count>0){
            flag=false;
        }
        return flag;
    }

}
