package com.diagbot.facade.data;

import com.alibaba.fastjson.JSON;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.generator.config.rules.NamingStrategy;
import com.diagbot.dto.data.ColumnZhAndChDTO;
import com.diagbot.entity.MedTransferOutNote;
import com.diagbot.service.impl.MedTransferOutNoteServiceImpl;
import com.diagbot.util.DateUtil;
import com.diagbot.util.EntityUtil;
import com.diagbot.util.MapUtil;
import com.diagbot.vo.data.AMedTransferOutNoteVO;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Date;
import java.util.List;
import java.util.Map;

@Component
public class AMedTransferOutNoteFacade extends MedTransferOutNoteServiceImpl {

    @Autowired
    private ColumnFacade columnFacade;
    @Autowired
    private AMedAbnormalInfoFacade aMedAbnormalInfoFacade;

    public void getColumnZhAndCh(){
        List<ColumnZhAndChDTO> list=this.baseMapper.getColumnZhAndCh();
        list.forEach(s->{
            s.setEn(NamingStrategy.underlineToCamel(s.getEn()));
        });

        Map<String, String> columnMap= EntityUtil.makeMapWithKeyValue(list,"ch","en");
        Boolean flag=columnFacade.createColumn(columnMap,"medTransferOutNote");

        //Map<String, String> map=columnFacade.getColumn("medConsultationNote");
        if(!flag){
            return;
        }
    }

    public void dealData(String columnMap,Map<String, Object> entityMap,Long hospitalId){
        try {
            AMedTransferOutNoteVO medTransferOutNoteVO=(AMedTransferOutNoteVO) MapUtil.mapToObject(entityMap, AMedTransferOutNoteVO.class);
            MedTransferOutNote medTransferOutNote=new MedTransferOutNote();
            BeanUtils.copyProperties(medTransferOutNoteVO,medTransferOutNote);
            medTransferOutNote.setHospitalId(hospitalId);//医院编码
            medTransferOutNote.setTransferInDate(DateUtil.parseDateTime(medTransferOutNoteVO.getTransferInDate()));
            medTransferOutNote.setAuditDate(DateUtil.parseDateTime(medTransferOutNoteVO.getAuditDate()));//审核时间
            medTransferOutNote.setRecDate(DateUtil.parseDateTime(medTransferOutNoteVO.getRecDate()));//记录时间
            medTransferOutNote.setRecordDate(DateUtil.parseDateTime(medTransferOutNoteVO.getRecordDate()));//病历日期

            medTransferOutNote.setWholeData(columnMap);
            //判断数据库中是否存在，不存在insert
            if(isExist(medTransferOutNote)){
                medTransferOutNote.setGmtCreate(new Date());//记录创建时间
                this.save(medTransferOutNote);
            }else{
                medTransferOutNote.setGmtModified(new Date());//记录修改时间
                this.update(medTransferOutNote,new QueryWrapper<MedTransferOutNote>()
                        .eq("rec_id", medTransferOutNote.getRecId())
                        .eq("hospital_id", medTransferOutNote.getHospitalId())
                        .eq("behospital_code", medTransferOutNote.getBehospitalCode()));
            }
        }catch (Exception e){
            log.error(e.getMessage(),e);
            aMedAbnormalInfoFacade.saveAbnormalInfo("转出记录", JSON.toJSONString(entityMap),"",e.getMessage());
        }

    }

    public Boolean isExist(MedTransferOutNote medTransferOutNote){
        Boolean flag=true;
        int count = this.baseMapper.selectCount(new QueryWrapper<MedTransferOutNote>()
                .eq("rec_id", medTransferOutNote.getRecId())
                .eq("hospital_id", medTransferOutNote.getHospitalId())
                .eq("behospital_code", medTransferOutNote.getBehospitalCode()));
        if(count>0){
            flag=false;
        }
        return flag;
    }
}
