package com.diagbot.facade.data;

import com.alibaba.fastjson.JSON;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.generator.config.rules.NamingStrategy;
import com.diagbot.dto.data.ColumnZhAndChDTO;
import com.diagbot.entity.MedWardRecord;
import com.diagbot.service.impl.MedWardRecordServiceImpl;
import com.diagbot.util.DateUtil;
import com.diagbot.util.EntityUtil;
import com.diagbot.util.MapUtil;
import com.diagbot.vo.data.AMedWardRecordVO;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Date;
import java.util.List;
import java.util.Map;

@Component
public class AMedWardRecordFacade extends MedWardRecordServiceImpl {
    @Autowired
    private ColumnFacade columnFacade;
    @Autowired
    private AMedAbnormalInfoFacade aMedAbnormalInfoFacade;

    public void getColumnZhAndCh(){
        List<ColumnZhAndChDTO> list=this.baseMapper.getColumnZhAndCh();
        list.forEach(s->{
            s.setEn(NamingStrategy.underlineToCamel(s.getEn()));
        });

        Map<String, String> columnMap= EntityUtil.makeMapWithKeyValue(list,"ch","en");
        Boolean flag=columnFacade.createColumn(columnMap,"medWardRecord");

        //Map<String, String> map=columnFacade.getColumn("medConsultationNote");
        if(!flag){
            return;
        }
    }

    //查房记录
    public void dealData(String columnMap,Map<String, Object> entityMap,Long hospitalId){
        try {
            AMedWardRecordVO medWardRecordVO=(AMedWardRecordVO) MapUtil.mapToObject(entityMap, AMedWardRecordVO.class);
            MedWardRecord medWardRecord=new MedWardRecord();
            BeanUtils.copyProperties(medWardRecordVO,medWardRecord);
            medWardRecord.setHospitalId(hospitalId);//医院编码

            medWardRecord.setAuditDate(DateUtil.parseDateTime(medWardRecordVO.getAuditDate()));//审核时间
            medWardRecord.setRecDate(DateUtil.parseDateTime(medWardRecordVO.getRecDate()));//记录时间
            medWardRecord.setWardDate(DateUtil.parseDateTime(medWardRecordVO.getWardDate()));//查房日期
            medWardRecord.setRecordDate(DateUtil.parseDateTime(medWardRecordVO.getRecordDate()));//病历日期

            medWardRecord.setWholeData(columnMap);
            //判断数据库中是否存在，不存在insert
            if(isExist(medWardRecord)){
                medWardRecord.setGmtCreate(new Date());//记录创建时间
                this.save(medWardRecord);
            }else{
                medWardRecord.setGmtModified(new Date());//记录修改时间
                this.update(medWardRecord,new QueryWrapper<MedWardRecord>()
                        .eq("rec_id", medWardRecord.getRecId())
                        .eq("hospital_id", medWardRecord.getHospitalId())
                        .eq("behospital_code", medWardRecord.getBehospitalCode()));
            }

        }catch (Exception e){
            log.error(e.getMessage(),e);
            aMedAbnormalInfoFacade.saveAbnormalInfo("查房记录", JSON.toJSONString(entityMap),"",e.getMessage());
        }

    }

    public Boolean isExist(MedWardRecord medWardRecord){
        Boolean flag=true;
        int count = this.baseMapper.selectCount(new QueryWrapper<MedWardRecord>()
                .eq("rec_id", medWardRecord.getRecId())
                .eq("hospital_id", medWardRecord.getHospitalId())
                .eq("behospital_code", medWardRecord.getBehospitalCode()));
        if(count>0){
            flag=false;
        }
        return flag;
    }
}
