package com.diagbot.util;

import com.diagbot.facade.data.*;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.ApplicationArguments;
import org.springframework.boot.ApplicationRunner;
import org.springframework.stereotype.Component;

@Slf4j
@Component
/**
 * 启动时执行缓存，将字段名和注释存储到MAP类型的缓存中
 */
public class ColumnCacheUtil implements ApplicationRunner {


    @Override
    public void run(ApplicationArguments args) throws Exception {
        try {
            aMedBloodResultFacade.getColumnZhAndCh();
            aMedBloodTransfusionFacade.getColumnZhAndCh();
            aMedAdmissionNoteFacade.getColumnZhAndCh();//入院记录
            aMedFirstRecordFacade.getColumnZhAndCh();
            aMedPeriodConclusionFacade.getColumnZhAndCh();
            aMedTransferInNoteFacade.getColumnZhAndCh();
            aMedTransferOutNoteFacade.getColumnZhAndCh();
            aMedIllSeriouslFacade.getColumnZhAndCh();
            aMedIllCriticallyFacade.getColumnZhAndCh();
            aMedDifficultCaseFacade.getColumnZhAndCh();
            aMedDeathNoteFacade.getColumnZhAndCh();
            aMedDeathDiscussionFacade.getColumnZhAndCh();
            aMedWardRecordFacade.getColumnZhAndCh();
            aMedOperativeFirstRecord.getColumnZhAndCh();
            aMedPreoperativeDiscussionFacade.getColumnZhAndCh();
            aMedOperativeNoteFacade.getColumnZhAndCh();
            aMedRescueNoteFacade.getColumnZhAndCh();
            aMedCrisisNoteFacade.getColumnZhAndCh();
            aMedLeaveHospitalFacade.getColumnZhAndCh();
            aMedConsultationApplyFacade.getColumnZhAndCh();
            aMedConsultationResultFacade.getColumnZhAndCh();
            aMedConsultationNoteFacade.getColumnZhAndCh();

            log.info("列名和注释缓存初始化完成！");
        }catch (Exception e){
            log.error(e.getMessage(),e);
        }
    }
    @Autowired
    private AMedAdmissionNoteFacade aMedAdmissionNoteFacade;
    @Autowired
    private AMedFirstRecordFacade aMedFirstRecordFacade;
    @Autowired
    private AMedPeriodConclusionFacade aMedPeriodConclusionFacade;
    @Autowired
    private AMedBloodResultFacade aMedBloodResultFacade;
    @Autowired
    private AMedBloodTransfusionFacade aMedBloodTransfusionFacade;
    @Autowired
    private AMedTransferInNoteFacade aMedTransferInNoteFacade;
    @Autowired
    private AMedTransferOutNoteFacade aMedTransferOutNoteFacade;
    @Autowired
    private AMedIllSeriouslFacade aMedIllSeriouslFacade;
    @Autowired
    private AMedIllCriticallyFacade aMedIllCriticallyFacade;
    @Autowired
    private AMedDifficultCaseFacade aMedDifficultCaseFacade;
    @Autowired
    private AMedDeathNoteFacade aMedDeathNoteFacade;
    @Autowired
    private AMedDeathDiscussionFacade aMedDeathDiscussionFacade;
    @Autowired
    private AMedWardRecordFacade aMedWardRecordFacade;
    @Autowired
    private AMedOperativeFirstRecord aMedOperativeFirstRecord;
    @Autowired
    private AMedPreoperativeDiscussionFacade aMedPreoperativeDiscussionFacade;
    @Autowired
    private AMedOperativeNoteFacade aMedOperativeNoteFacade;
    @Autowired
    private AMedRescueNoteFacade aMedRescueNoteFacade;
    @Autowired
    private AMedCrisisNoteFacade aMedCrisisNoteFacade;
    @Autowired
    private AMedLeaveHospitalFacade aMedLeaveHospitalFacade;
    @Autowired
    private AMedConsultationApplyFacade aMedConsultationApplyFacade;
    @Autowired
    private AMedConsultationResultFacade aMedConsultationResultFacade;
    @Autowired
    private AMedConsultationNoteFacade aMedConsultationNoteFacade;
}
